/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard

Project : Termometr
Version : 0.0.1 ( ,    LED ) 
Date    : 02.02.2008 ( )
Author  : Danil                          
Comments:        ds18b20.lib
               int    float

Chip type           : ATtiny2313
Clock frequency     : 4,000000 MHz
Memory model        : Tiny
External SRAM size  : 0
Data Stack size     : 32
*****************************************************/

// -----------------------------------------
// 
// EEPROM usage: 0 byte(s), 0,0% of EEPROM
// Program size: 765 words (1530 bytes), 74,7% of FLASH

// -----------------------------------------
//
//   DS18B20 - (PORTA bit 0)
//
//    (.)
//                   (PORTB - ) - 1-bit0, 2-bit1, 3-bit2, 4-bit3, 5-bit4, 6-bit5, 7-bit6, 8-bit7
//                   (PORTD - ) - a-bit0, b-bit1, c-bit2, d-bit3, e-bit4, f-bit5, g-bit6                  
//                   (PORTA bit 1 -  dp)

//  -          ,    IBM PC XT   Intel 8088 
#include <tiny2313.h>

// 1 Wire Bus functions (PORTA bit 0)
#asm
   .equ __w1_port=0x1b
   .equ __w1_bit=0
#endasm
//#include <1wire.h>

// DS18b20 Temperature Sensor functions
#include "ds18b20_.h"  
#include <delay.h>         

unsigned char digit_out[8], cur_dig;
int temperature1, temperature2;          

// ,   . 
#include "term_OA.h"        

// Timer 0 overflow interrupt service routine
//
//     = 50  (8  = 8  50  = 400 )
//
//  -   256 (0xFF)  ,
//   3906     (3906  / 256) = 15,26 
//
//     400   3906  / 400 = 9   (   )
// -     256 - 9 = 247 = 0xF7 
//
interrupt [TIM0_OVF] void timer0_ovf_isr(void) {

        //      ,   247 = 0xF7
        TCNT0=0xF7;

        PORTB=0x00;                             //   (   "0" -  .)
        PORTD=digits[digit_out[cur_dig]];       //   
        PORTA.1=1;
        PORTB = (1 << cur_dig);                //    (   "1" -  .)
        
        if ( ((cur_dig == 2) || (cur_dig == 6)) && (zpt == ON) ) PORTA.1=0; //       ( .  )
                
        cur_dig++; if (cur_dig>=8) cur_dig=0;
}

// Declare your global variables here
void hex_to_dec(int, unsigned char);

void main(void) { //================================================= main ========================================================
// Crystal Oscillator division factor: 1
CLKPR=0x80;
CLKPR=0x00;

//   (bit 0      , bit 1  ) 
DDRA=0x02;
PORTA=0x00;

//  B   (   0)
DDRB=0xFF;
PORTB=0x00;

//  D   (   1)
DDRD=0xFF;
PORTD=0xFF;


// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 3,906 kHz
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x05;
TCNT0=0xF7;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// Interrupt on any change on pins PCINT0-7: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x02;

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
USICR=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;

// 1 Wire Bus initialization
w1_init();
 
 zpt = OFF;
 devices=w1_search(0xf0,rom_code);
 
 // Global enable interrupts
#asm("sei")                     

 //  1,5     Fnd '-  '
 digit_out[0]=13;    // F
 digit_out[1]=14;    // n
 digit_out[2]=15;    // d
 digit_out[3]=devices; // 'devices'
 digit_out[4]=PROBEL;
 digit_out[5]=PROBEL;
 digit_out[6]=PROBEL;
 digit_out[7]=PROBEL;
 delay_ms(1500);
    
 // --------------------------------   -----------------------------------
 while (1) {
        
        // -----------------------------------------------------------
        if (devices == 1) { //     
                temperature1=ds18b20_temperature(&rom_code[0][0]); 
                if (temperature1!=-9999) hex_to_dec(temperature1, 1);
        }

        // -----------------------------------------------------------
        if (devices > 1) { //      
                temperature1=ds18b20_temperature(&rom_code[0][0]);
                temperature2=ds18b20_temperature(&rom_code[1][0]);
                zpt = ON;
                if (temperature1!=-9999) hex_to_dec(temperature1, 1); 
                if (temperature2!=-9999) hex_to_dec(temperature2, 2);
        }        
        devices=w1_search(0xf0,rom_code); //   ( )
        delay_ms(2000);
        
 } // -----------------------------   (end) -----------------------------------

} // =============================================================== end main ==================================================

  

// -----------------------------------------------------------------------------------------------------------------------------
void hex_to_dec(int temperature, unsigned char dig) {
        char i, d0, d1, d2, d3;
        unsigned char celie, drob;
        unsigned int temp, celie_tmp, drob_tmp;
 
        if (dig == 1) {d0=0; d1=1; d2=2; d3=3;}
        if (dig == 2) {d0=4; d1=5; d2=6; d3=7;}
        
        temp = (unsigned int) temperature;                      
        
        if (temperature>=0) {
                digit_out[d0]=PROBEL;       //   ()  
        } 
        else {        
                temp = ( ~temp ) + 0x0001; //       . 
                digit_out[d0]=MINUS;        //     (   ..)
             };

        celie_tmp = temp >> 4;     //   
        drob_tmp  = temp & 0x000F; //      1/16 
                
        celie = (unsigned char) celie_tmp;  //     
        drob  = (unsigned char) ((drob_tmp * 10) / 16); //      "1/16 "      0,1  
              
        i=0;
        while (celie >= 100) {     //  
                 celie=celie-100;
                 i++;
        };
                                
        if (i) digit_out[d0]=i;     //    ...     ..    '010,0' ,  '10,0'  
                        
        i=0;
        while (celie >= 10) {      // 
                 celie=celie-10;
                 i++;
        };
        
        if ( (celie_tmp < 10) && (i == 0) ) {
                    if (digit_out[d0] == MINUS) {    //       10                     
                           digit_out[d0]=PROBEL;     //              ..    '- 1,0' ,  '-1,0'
                           digit_out[d1]=MINUS;
                    }
                    else { digit_out[d1]=PROBEL; }   //    ..    '01,0' ,  '1,0'
        }
        else  {   digit_out[d1]=i;  } 
        
        digit_out[d2]=celie;       // 
        digit_out[d3]=drob;        //  
}

//
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= The End -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
                                                                              